=== tests/example/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

function(POSITIVE_TEST NAME)
    souffle_positive_test(${NAME} example ${ARGN})
endfunction()

function(NEGATIVE_TEST NAME)
    souffle_negative_test(${NAME} example)
endfunction()

positive_test(2sat)
positive_test(access-policy)
positive_test(ackermann)
positive_test(amicable)
positive_test(andersen)
positive_test(array)
positive_test(bigrams)
positive_test(catalan)
positive_test(cba_expr_value)
positive_test(cellular_automata)
positive_test(centroids)
positive_test(circuit_eval)
positive_test(circuit_records)
positive_test(circuit_sat)
positive_test(clique)
positive_test(cliquer)
positive_test(comp-parametrized-inherit)
positive_test(comp-parametrized-multilvl)
positive_test(comp-parametrized)
positive_test(convex_hull)
positive_test(counter)
positive_test(degree)
positive_test(dfa)
positive_test(dfa_live_vars)
positive_test(dfa_min)
positive_test(dfa_parse)
positive_test(dfa_summary_function)
positive_test(disconnected)
positive_test(dnf)
positive_test(dominance)
positive_test(double_tree)
positive_test(earley)
positive_test(edit_distance)
positive_test(equal)
positive_test(euclid)
positive_test(factorial)
positive_test(factoring)
positive_test(family)
positive_test(fib)
positive_test(fib1)
positive_test(flights)
positive_test(flights2)
positive_test(floydwarshall)
positive_test(fractional_knapsack)
positive_test(func)
positive_test(game2)
positive_test(grad)
positive_test(graph)
positive_test(grid)
positive_test(highest_degree)
positive_test(hmmer)
positive_test(independent_body3)
positive_test(inline_nats)
positive_test(input_output)
positive_test(java-pointsto)
positive_test(josephus)
positive_test(k-permutations)
positive_test(linksum)
positive_test(longest_path)
positive_test(lubm)
souffle_positive_multi_test(TEST_NAME lucas CATEGORY example FACTS_DIR_NAMES fibonacci lucas mersenne pell)
positive_test(magic_access-policy)
positive_test(magic_prime2)
positive_test(magic_pointsto)
positive_test(metro)
positive_test(minesweeper)
positive_test(minimum_spanning_tree)
positive_test(minpath1)
positive_test(minpath2)
positive_test(minpath3)
positive_test(mmult)
positive_test(movies)
souffle_positive_multi_test(TEST_NAME nfsa2fsa CATEGORY example FACTS_DIR_NAMES ex1 ex2)
positive_test(not_match)
positive_test(nqueens)
positive_test(orbits1)
positive_test(orbits)
positive_test(palindrome)
positive_test(paths)
positive_test(peano_arithmetic)
positive_test(perfect_numbers)
positive_test(planar)
positive_test(po1)
positive_test(po2)
positive_test(po3)
positive_test(po4)
positive_test(po5)
positive_test(pointsto)
positive_test(prime2)
positive_test(prime)
positive_test(profile_default)
positive_test(profile_json)
positive_test(puzzle)
positive_test(ranpo)
positive_test(recipes)
positive_test(rsg)
positive_test(rewrite)
positive_test(sequences)
positive_test(ship)
positive_test(shortest_edges)
positive_test(shortest_path)
positive_test(shortest_path2)
positive_test(small)
positive_test(sort)
positive_test(speed)
positive_test(strategies)
positive_test(tak)
positive_test(tc)
positive_test(tic-tac-toe)
positive_test(topological_ordering)
positive_test(traffic)
positive_test(trains)
positive_test(trans)
positive_test(tree)
positive_test(triangle)
positive_test(turing1)
positive_test(weighted_distances)
