=== tests/libsouffle_interface/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2022 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

souffle_add_binary_test(vfs_overlay_test libsouffle)
souffle_add_binary_test(souffle_doc_test libsouffle)
