=== debian/changelog ===
souffle (2.5.0) stable; urgency=low
 * Lattice support
 * Doc comments and annotations
 * Relations with arity up to 22 in intepreter
 * Let `to_number` infer the base
 * Misc fixes and refactoring

 -- Quentin Sabah <quentin.sabah@gmail.com> Wed, 12 Mar 2025 20:00:00 +0100

souffle (2.4.1) stable; urgency=low
 * Remove escapes in arch build (XiaowenHu96)
 * fix windows CI (quentin)
 * Fix subsumption (julienhenry)
 * remove -Werror from CMakeLists.txt (ammkrn)
 * Provide way to debug delta relations and expose iteration counter (julienhenry)
 * fix "variable only occurs once" checker (quentin)
 * fix bad source location for END token (quentin)
 * Fix generated code for eqrel when emitting statistics (fangyi-zhou)
 * do not consider debug_delta relations as empty (julienhenry)
 * Fix auto-scheduler profile mismatch (fangyi-zhou)
 * fixes souffleprof and enable build on Windows (quentin)
 * Enabling souffle-lang/souffle GitHub dependency graph with vcpk (#2427) (quentin)
 * fix sqlite reading of empty values (dbueno)
 * symbol concatenation with binary `+` (quentin)

 -- Quentin Sabah <quentin.sabah@gmail.com>  Wed, 11 Oct 2023 11:00:00 +0100

souffle (2.4) stable; urgency=low
 * New option --generate-many to split the generated C++ Code into multiple files (julienhenry)
 * Purge input and intermediate relations (adamjseitz)
 * Emscripten Build (philzook58)
 * Improved parallel load balance in the interpreter (quentin)
 * User defined aggregate (julienhenry)
 * Improved loading of CSV (strRM, bmeck)
 * Configurable warnings (langston-barrett)
 * Performance improvements for regex matching (strRM)
 * Expose main driver interface (quentin)
 * Allow linking against multiple compiled Souffle programs (ruricolist, quentin)
 * Misc fixes and refactoring (adamjseitz, ruricolist, quentin, b-scholz, mingodad, bmeck, strRM, fgauthie, julienhenry, SamArch27, luc-tielen, XiaowenHu96, Gueckmooh)

 -- Quentin Sabah <quentin.sabah@gmail.com>  Sat, 18 Feb 2023 11:00:00 +0100

souffle (2.3) stable; urgency=low
 * Auto-scheduler for rules (SamArch27)
 * Better scheduling heuristic (julienhenry)
 * Improved component system (quentin)
 * Improved type-system for record alias (quentin)
 * Introducing include directives (quentin)
 * Optional use of libffi (quentin)
 * New packaging mechanism using souffle-lang.github.io (XiaowenHu96, mmcgr)
 * Misc fixes and refactoring (langston-barrett, aeflores, pnwamk, quentin, b-scholz, XiaowenHu96, OlivierHamel, cwarden, mbid, davidwzhao, cmuellner, luc-tielen)

 -- Bernhard Scholz <Bernhard.Scholz@sydney.edu.au>  Sat, 14 May 2022 22:24:08 +1000 

souffle (2.2-1) stable; urgency=low

  * Subsumption clauses, e.g., A(x1) <= A(x2) :- x1 <= x2 (@julienhenry, @b-scholz)
  * IR and build improvements (@OlivierHamel, @langston-barrett, @quentin, @b-scholz, @aeflores, @cmuellner, @broffra, @rahlk, @yihozhang, @trofi)
  * Refactoring of type analysis (@tytus-metrycki)
  * Improved packaging (@XiaowenHu96, @quentin, @uxhg, @cwarden)
  * Improved loading of DLLs (@quentin)
  * Type annotation printer (@hide-kawabata)
  * Performance improvements for eqrel (@langston-barrett, @kevzhumba)

 -- Bernhard Scholz <Bernhard.Scholz@sydney.edu.au>  Mon, 17 Jan 2022 12:34:01 +1100

souffle (2.1) stable; urgency=low

  * Choice domain (@XiaowenHu96)
  * Proper treatment of escape codes in symbol constants (@lyxell)
  * CSV output has rfc4180 flag for delimiters (@quentin)
  * Fix UDF syntax (@TomasPuverle)
  * Add no_magic/no_inline relational qualifiers (@sharon-wang)
  * Retire $; replace by autoinc() (@b-scholz)
  * Suppress file errors with -w flag (@b-scholz)
  * Re-implementation of the ast-to-ram translator (@azreika)
  * Added Cmake PORT support (@XiaowenHu96, @quentin
  * GitHub Action (@XiaowenHu96, @quentin, @XiaowenHu96, @b-scholz, @lyxell,@quentin,@OlivierHamel)
  * Debian Packaging and CodeCov support in GitHub Action/Cmake (@phao5814)
  * Lock-free record/symbol tables (@quentin)
  * Interpreter refactoring / fixing (@XiaowenHu96)
  * Type Analysis Refactoring (@azreika, @tytus-metrycki)
  * New SIPS strategy (@langston-berrett)
  * Refactor AST & RAM & Provenance (@TomasPuverle, @b-scholz, @azreika)
  * RAM Optimisation (@SamArch27)
  * Multiple library flag (@mclements)
  * Added “max-bound-delta” SIPS (@langston-barrett)
  * General Fixes and improvements (@b-scholz, @csabahruska, @julienhenry, @langston-berrett, @mmcgr, @TomasPuverle, @quentin,@XiaowenHu96)
  * Add fuzzing scripts with AFL and Radamsa (@langston-barrett)

 -- Bernhard Scholz <Bernhard.Scholz@sydney.edu.au>  Tue, 17 Aug 2021 12:08:04 +1100

souffle (2.0.2); urgency=low

  * Fix OSX user library paths (mmcgr)
  * Fix concurrent profling (mmcgr)
  * Fix indirect index use (aeflores)
  * Fix 'as' type conversion (darth-tytus)
  * Fix output of hint statistics (azreika)
  * Implement Record/ADT user-defined functors (darth-tytus)
  * Optimise ADT encoding (darth-tytus)
  * Added limitsize directive (b-scholz)
  * Add heuristic-based clause reordering (azreika)
  * Enhanced Magic Set transformation (azreika)
  * Restructuring for readability and maintainability (b-scholz, mmcgr)

 -- Martin McGrane <mmcgrane@it.usyd.edu.au>  Fri, 25 Sep 2020 11:10:35 +1000

souffle (2.0.1); urgency=low

  * Stop overmaterialising aggregate bodies (rdowavic)
  * Parallelise aggregate computation (rdowavic)
  * Add JSON IO (GaloisNeko)
  * Extend program minimiser (azreika)
  * Use greater precision for floating point output (mmcgr)
  * Fix duplicated symbols with multiple souffle object files (luc-tielen)
  * Fix multithreaded, interpreted, provenance (taipan-snake)
  * Fix provenance constraint explanation (taipan-snake)
  * Fix path detection for souffle tools (mmcgr)
  * Fix output directory use (mmcgr)

 -- Martin McGrane <mmcgrane@it.usyd.edu.au>  Wed, 29 Jul 2020 11:54:01 +1100

souffle (2.0.0); urgency=low

  * Added `--legacy` flag to allow use of legacy options (darth-tytus)

