=== debian/control ===
Source: souffle
Maintainer: Martin McGrane <mmcgrane@it.usyd.edu.au>
Section: misc
Priority: optional
Standards-Version: 4.3.0
Build-Depends: autoconf, automake, bash-completion, bison, debhelper (>= 11), flex, g++ (>= 7), libffi-dev, libncurses5-dev, libsqlite3-dev, mcpp, sqlite3, zlib1g-dev
Homepage: https://souffle-lang.org/
Vcs-Git: https://github.com/souffle-lang/souffle.git

Package: souffle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, g++ (>= 7), libffi-dev, libncurses5-dev, libsqlite3-dev, mcpp, zlib1g-dev
Description: Translator of declarative Datalog programs into the C++ language.
 Soufflé is a translator of declarative Datalog programs into the C++ language.
 Soufflé is used as a domain-specific language for static program analysis, over
 large code bases with millions of lines of code. Soufflé aims to produce
 high-performance C++ code that can be compiled with the native compiler on
 the target machine.
