=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with bash-completion

# debuild somehow finds /usr/local targets (which souffle does not use)
# and starts emitting warnings. The below code is to silence that.
override_dh_usrlocal:
